# Decision Tree Classification (ML\_CN\_6)

This algorithm works by creating a tree-like model of decisions and their possible consequences. The model starts with a root node that represents the entire dataset and branches out into different nodes that represent possible decisions or features that can be used to split the data into smaller groups.

At each node, the algorithm chooses the feature that results in the greatest information gain, meaning the feature that provides the most information about the class labels of the data points. The process continues recursively until a leaf node is reached, which represents a final decision or classification for the data point.

Decision tree classification is a popular algorithm because it is easy to understand and interpret, and it can work well with both categorical and numerical data.

## Sample Request

Build a Decision Tree Classification model named, *"ClassicModel"*

```javascript
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "ML_CN_6",
    "args": {
        "model_name": "ClassicModel",
        "criterion": "gini",
        "random_state": 0
    }
}
```

## Building a Decision Tree Classification model

## Decision Tree Classification&#x20;

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                                                                                                                                            |
| ------------------------------------------------ | ------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                                                                                                                                                        |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                                                                                                                                                          |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                                                                                                                                                    |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                                                                                                                                                         |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                                                                                                                                                                        |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of the model to be used for prediction.                                                                                                                                           |
| criterion                                        | String | function to measure the quality of a split. Supported criteria are “gini” for the Gini impurity and “log\_loss” and “entropy” both for the Shannon information gain (defaults to gini) |
| random\_state                                    | int    | Controls the randomness of the estimator (defaults to 0).                                                                                                                              |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"ClassicModel\": {\"function_code\": \"ML_R_3\", \"model_url\": ""}}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeClassification = await client.decision_tree_classification(project_id, parent_id, block_id, {
    model_name: "ClassicModel",
    criterion: "gini",
    random_state: 0
});
```

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the pre-built model passing an optional test data.

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_CN_6_P",
    "args": {
        "model_name": "ClassicModel",
        "test_data": ""
    }
}
```

## Predicting with Decision Tree Classification

## Decision Tree Classification  Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                            |
| ------------------------------------------------ | ------ | ---------------------------------------------------------------------- |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of previously trained model to be used for prediction             |
| test\_data                                       | String | Input data for prediction. Defaults to `x_train_url` in StateManagment |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project                                              |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block                                                |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block                                               |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block                                    |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"y_pred_url\": ""}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

<pre class="language-javascript"><code class="lang-javascript">const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeClassificationPredict = await client.decision_tree_classification_predict(project_id, parent_id, block_id, {
<strong>    model_name: "ClassicModel",
</strong><strong>    test_data: ""
</strong>});
</code></pre>

{% endtab %}
{% endtabs %}

## Sample Request

Evaluate model metrics

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_CN_6_M",
    "args": {
        "model_name": "ClassicModel"
    }
}
```

## Decision Tree Classification Metrics

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                             |
| ------------------------------------------------ | ------ | ------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project                               |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block                                |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block                                 |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block                     |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of the pre-trained model to be used for evaluation |

{% tabs %}
{% tab title="200: OK StateManagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 1,
        "project": 12,
        "block_id": 10,
        "parent_id": 11,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{'confusion_matrix': '', 'accuracy': 0.9}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeClassificationMetrics= await client.decision_tree_classification_metrics(project_id, parent_id, block_id, {
    model_name: "SimpleModel",

});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/machine-learning/decision-tree-classification-ml_cn_6.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
